module MosmlPrelude where

src = unlines 
      [ "Meta.quietdec := true;"
      , "fun head (x::l) = x | head [] = raise Fail \"head: empty list\";"
      , "fun tail (x::l) = l | tail [] = raise Fail \"tail: empty list\";"
      , "fun cons x l = x :: l;"
      , "fun /= (i, j) = (i:int) <> j;"
      , "fun == (i, j) = (i:int) = j;"
      , "val exists = List.exists;"
      , "infix == /=;"
      , "Meta.quietdec := false;"
      ]

-- a mapping from ML identifier to the corresponding phrac code
phracPrelude = 
    [ ("head", "\\x -> case x of Nil -> error \"head: empty list\"; Cons y _ -> y;")
    , ("tail", "\\x -> case x of Nil -> error \"tail: empty list\"; Cons _ l -> l;")
    , ("exists", "exists")
    , ("nil", "Nil")
    , ("cons", "Cons")
    , ("null", "null")
    , ("false", "False")
    , ("true", "True")
    ]